Lattice Grid Buy a licence

demo D57

Quick filter, four ways

contains, words, fuzzy and regex over the same box

filters.quick(text, { mode })

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  // The quick panel gives one box that matches across every column at once.
  // quickFilter seeds the opening term; clearing the box shows every row again.
  const columns = [
    { field: 'service', title: 'Service', layout: { width: 150 } },
    { field: 'team', title: 'Team' },
    { field: 'owner', title: 'Owner' },
    { field: 'region', title: 'Region' },
    { field: 'repository', title: 'Repository', layout: { flex: 1, min: 200 } },
    { field: 'instances', title: 'Instances', type: 'number' },
  ];

  const rows = [/* 2,000 service records */];

  function App() {
    return (
      <LatticeGrid
        rowKey="id"
        quickFilter="plat"
        toolPanel={{ side: 'left', panels: ['quick', 'filters', 'columns'], actions: ['restore'], exportName: 'lattice-demo' }}
        columns={columns}
        rows={rows}
        style={{ height: '540px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Free-text quick filtering across every visible column

A quick filter is the search box above a JavaScript data grid that narrows rows as a user types, without naming a column or opening a filter menu first. Reach for it whenever a table serves people who know roughly what they are looking for but not which column holds it: a support queue searched by customer name, ticket number, or note text at once, or a parts list searched by code or description. Lattice Grid exposes four matching strategies through filters.quick(text, { mode }): contains for a plain substring match, words to require each typed word independently regardless of order, fuzzy to tolerate a transposed letter or a missing character, and regex for a pattern typed straight into the box. Switching mode does not change what is indexed, so a user moving from a loose word search to a precise regex scans the same row set, not a second pass over different data. Matching runs against the rendered cell values already produced by each column’s formatter, so a currency column matches on “£1,200” as displayed, not the raw number. Because the filter narrows the row list rather than hiding cells, virtual scrolling still renders only the rows in view, so typing into the box on a hundred-thousand-row grid recomputes the match set without a drop in scroll frame rate.

How do you add a search box that filters a data grid as you type?

Call filters.quick(text, { mode }) with the current input value on every keystroke, passing contains, words, fuzzy, or regex as the mode. Lattice Grid matches against each row’s rendered cell text across all visible columns and updates the row list in place, so no column configuration is required before the box works.

Lattice Grid Buy a licence

demo D57

Quick filter, four ways

contains, words, fuzzy and regex over the same box

filters.quick(text, { mode })

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

// The quick panel gives one box that matches across every column at once.
// quickFilter seeds the opening term; clearing the box shows every row again.
const columns = [
  { field: 'service', title: 'Service', layout: { width: 150 } },
  { field: 'team', title: 'Team' },
  { field: 'owner', title: 'Owner' },
  { field: 'region', title: 'Region' },
  { field: 'repository', title: 'Repository', layout: { flex: 1, min: 200 } },
  { field: 'instances', title: 'Instances', type: 'number' },
];

const rows = [/* 2,000 service records */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    quickFilter: 'plat',
    toolPanel: { side: 'left', panels: ['quick', 'filters', 'columns'], actions: ['restore'], exportName: 'lattice-demo' },
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Free-text quick filtering across every visible column

A quick filter is the search box above a JavaScript data grid that narrows rows as a user types, without naming a column or opening a filter menu first. Reach for it whenever a table serves people who know roughly what they are looking for but not which column holds it: a support queue searched by customer name, ticket number, or note text at once, or a parts list searched by code or description. Lattice Grid exposes four matching strategies through filters.quick(text, { mode }): contains for a plain substring match, words to require each typed word independently regardless of order, fuzzy to tolerate a transposed letter or a missing character, and regex for a pattern typed straight into the box. Switching mode does not change what is indexed, so a user moving from a loose word search to a precise regex scans the same row set, not a second pass over different data. Matching runs against the rendered cell values already produced by each column’s formatter, so a currency column matches on “£1,200” as displayed, not the raw number. Because the filter narrows the row list rather than hiding cells, virtual scrolling still renders only the rows in view, so typing into the box on a hundred-thousand-row grid recomputes the match set without a drop in scroll frame rate.

How do you add a search box that filters a data grid as you type?

Call filters.quick(text, { mode }) with the current input value on every keystroke, passing contains, words, fuzzy, or regex as the mode. Lattice Grid matches against each row’s rendered cell text across all visible columns and updates the row list in place, so no column configuration is required before the box works.